sc::MolecularFrequencies Class Reference

    The MolecularFrequencies class is used to compute the molecular

frequencies and thermodynamic information. More...

`#include <molfreq.h>`

Inheritance diagram for sc::MolecularFrequencies:
[legend]
Collaboration diagram for sc::MolecularFrequencies:
[legend]

## Public Member Functions

| MolecularFrequencies (const Ref< KeyVal > &)
| The KeyVal constructor. More...
| MolecularFrequencies (StateIn &)
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them. More...
Ref< Molecule > | molecule () const
| Return the molecule.
void | compute_frequencies (const RefSymmSCMatrix &xhessian)
| Given a cartesian coordinate hessian, compute the frequencies.
int | nirrep () const
| Returns the number if irreps.
int | nfreq (int irrep) const
| Returns the number of modes in an irrep. More...
double | freq (int irrep, int i) const
| Returns the frequency, given the irrep and the index. More...
RefSCMatrix | normal_coordinates ()
| This returns the normal coordinates generated by compute_frequencies. More...
void | thermochemistry (int degeneracy, double temp=298.15, double pres=1.0)
| Computes thermochemical information using information generated by calling compute_frequencies first. More...
void | animate (const Ref< Render > &, const Ref< MolFreqAnimate > &)
Ref< SCMatrixKit > | matrixkit ()
Ref< SCMatrixKit > | symmatrixkit ()
Public Member Functions inherited from sc::SavableState
SavableState & | operator= (const SavableState &)
void | save_state (StateOut &)
| Save the state of the object as specified by the StateOut object. More...
void | save_object_state (StateOut &)
| This can be used for saving state when the exact type of the object is known for both the save and the restore. More...
virtual void | save_vbase_state (StateOut &)
| Save the virtual bases for the object. More...
Public Member Functions inherited from sc::DescribedClass
| DescribedClass (const DescribedClass &)
DescribedClass & | operator= (const DescribedClass &)
ClassDesc * | class_desc () const throw ()
| This returns the unique pointer to the ClassDesc corresponding to the given type_info object. More...
const char * | class_name () const
| Return the name of the object's exact type.
int | class_version () const
| Return the version of the class.
virtual void | print (std::ostream &=ExEnv::out0()) const
| Print the object.
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Additional Inherited Members

Static Public Member Functions inherited from sc::SavableState
static void | save_state (SavableState *s, StateOut &)
static SavableState * | restore_state (StateIn &si)
| Restores objects saved with save_state. More...
static SavableState * | key_restore_state (StateIn &si, const char *keyword)
| Like restore_state, but keyword is used to override values while restoring. More...
static SavableState * | dir_restore_state (StateIn &si, const char *objectname, const char *keyword=0)
Protected Member Functions inherited from sc::SavableState
| SavableState (const SavableState &)
| SavableState (StateIn &)
| Each derived class StateIn CTOR handles the restore corresponding to calling save_object_state, save_vbase_state, and save_data_state listed above. More...

## Detailed Description

    The MolecularFrequencies class is used to compute the molecular

frequencies and thermodynamic information.

## Constructor & Destructor Documentation

sc::MolecularFrequencies::MolecularFrequencies | ( | const Ref< KeyVal > & |  | ) |

The KeyVal constructor.

`mole`

  A MolecularEnergy object. If this is not given then molecule must be given.

`molecule`

  A Molecule object. If this is not given then mole must be given.

`point_group`

  A PointGroup object. This is the point group used to compute the finite displacements. Since some MolecularEnergy objects cannot handle changes in the molecule's point group, the molecule must be given symmetry for frequency calculations. In this case, the point_group keyword can be given to reduce number of the displacements needed to compute the frequencies. If this is not given then the point group of the molecule is used.

`debug`

  An integer which, if nonzero, will cause extra output.

`displacement`

  The amount that coordinates will be displaced. The default is 0.001.

## Member Function Documentation

double sc::MolecularFrequencies::freq | ( | int | irrep,
|  | int | i
| ) |  | const

inline

Returns the frequency, given the irrep and the index.

compute_frequencies must be called first.

int sc::MolecularFrequencies::nfreq | ( | int | irrep | ) | const

inline

Returns the number of modes in an irrep.

compute_frequencies must be called first.

RefSCMatrix sc::MolecularFrequencies::normal_coordinates | ( |  | ) |

inline

This returns the normal coordinates generated by compute_frequencies.

void sc::MolecularFrequencies::save_data_state | ( | StateOut & |  | ) |

virtual

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::SavableState.

void sc::MolecularFrequencies::thermochemistry | ( | int | degeneracy,
|  | double | temp = `298.15`,
|  | double | pres = `1.0`
| ) |  |

Computes thermochemical information using information generated by calling compute_frequencies first.

The documentation for this class was generated from the following file:

- molfreq.h